﻿<script src="~/assets/plugins/select2/js/select2.full.min.js" type="text/javascript"></script>
<script src="~/assets/plugins/jquery-validation/jquery.validate.min.js" type="text/javascript"></script>
<script src="~/assets/plugins/jquery-validation/additional-methods.min.js" type="text/javascript"></script>

<!-- Plugin Search Select2 -->
<script type="text/javascript">
    $(document).ready(function () {
        $('.select2me').each(function () {
            $(this).select2({
                theme: 'bootstrap4',
                width: $(this).data('width') ? $(this).data('width') : $(this).hasClass('w-100') ? '100%' : 'style',
                placeholder: $(this).data('placeholder'),
                allowClear: Boolean($(this).data('allow-clear')),
                closeOnSelect: !$(this).attr('multiple'),
            });
        });
    });
</script>

<!-- Xét chiều cao - fixed table -->
<script type="text/javascript">
    var _height_Window = $(window).height();
    var _height_Header = $('.iq-top-navbar').height();
    var _height_Title = $('#box_title_table').height();
    var _height_Footer = $('.iq-footer').height();

    // console.log(_height_Window);
    // console.log(_height_Header);
    // console.log(_height_Title);
    // console.log(_height_Footer);
    /* Config scroll table - Xoá comment để kích hoạt */
    var flag_fixed = false;
    if ($(window).width() > 760) {
        var _total_heigt_grid = _height_Window - _height_Header - _height_Title - _height_Footer - 76 - 45;
        $('#gridContainer_User').height(_total_heigt_grid);
        $('#gridContainer_DonVi').height(_total_heigt_grid);
        flag_fixed = true;
    } else {
        var _total_heigt_grid = _height_Window - _height_Header - 15;
        $('#gridContainer_User').height(_total_heigt_grid);
        $('#gridContainer_DonVi').height(_total_heigt_grid);
        if ($(window).width() > 375) {
            flag_fixed = true;
        } else {
            flag_fixed = false;
        }
    }
</script>

<!-- User List - Setting isScan cho tài khoản -->
<script type="text/javascript">

    function load_danhsach_user(){
        $.ajax({
            url: '@Url.Action("GetDanhSachTaiKhoan", "VanPhongSo")',
            type: 'GET',
            dataType: 'json'
        })
        .done(function(response) {
            
            $('#gridContainer_User').dxDataGrid({
                dataSource: response,
                keyExpr: 'Id',
                showBorders: true,
                showRowLines: true,
                paging: {
                    enabled: false
                },
                columnAutoWidth: true,
                //columnHidingEnabled: true,
                //allowColumnResizing: true,
                columnFixing: {
                    enabled: true
                },
                filterRow: {
                    visible: true,
                    applyFilter: 'auto',
                },
                // filterPanel: { visible: true },
                headerFilter: { visible: true },
                columns:
                    [
                        {
                            headerCellTemplate: function(container) {
                                container.text('VPS').parent().css({fontWeight: 'bold', textAlign: 'center', backgroundColor: '#c5d3dd'});
                            },
                            width: 70,
                            fixed: true,
                            dataField: "isVPS",
                            alignment: "center",
                            cellTemplate: function (container, options) {
                                //console.log(options);
                                let _html = '';
                                if(options.data.isVPS){
                                    _html = `
                                    <input class="action_setting_isVPS cursor_pointer" type="checkbox" value="${options.data.isVPS}" data-id="${options.data.Id}" data-tendangnhap="${options.data.TenDangNhap}" checked="checked">
                                    `;
                                }else{
                                    _html = `
                                    <input class="action_setting_isVPS cursor_pointer" type="checkbox" value="${options.data.isVPS}" data-id="${options.data.Id}" data-tendangnhap="${options.data.TenDangNhap}">
                                    `;
                                }
                                $(container).html(_html);
                            }
                        },
                        {
                            headerCellTemplate: function(container) {
                                container.text('TP').parent().css({fontWeight: 'bold', textAlign: 'center', backgroundColor: '#c5d3dd'});
                            },
                            width: 80,
                            fixed: true,
                            dataField: "isTruongPhong",
                            alignment: "center",
                            cellTemplate: function (container, options) {
                                //console.log(options);
                                let _html = '';
                                if(options.data.isTruongPhong){
                                    _html = `
                                    <input class="action_setting_isTruongPhong cursor_pointer" type="checkbox" value="${options.data.isTruongPhong}" data-id="${options.data.Id}" data-tendangnhap="${options.data.TenDangNhap}" checked="checked">
                                    `;
                                }else{
                                    _html = `
                                    <input class="action_setting_isTruongPhong cursor_pointer" type="checkbox" value="${options.data.isTruongPhong}" data-id="${options.data.Id}" data-tendangnhap="${options.data.TenDangNhap}">
                                    `;
                                }
                                $(container).html(_html);
                            }
                        },
                        {
                            headerCellTemplate: function(container) {
                                container.text('Scan').parent().css({fontWeight: 'bold', textAlign: 'center', backgroundColor: '#c5d3dd'});
                            },
                            width: 80,
                            fixed: true,
                            dataField: "isScan",
                            alignment: "center",
                            cellTemplate: function (container, options) {
                                //console.log(options);
                                let _html = '';
                                if(options.data.isScan){
                                    _html = `
                                    <input class="action_setting_isScan cursor_pointer" type="checkbox" value="${options.data.isScan}" data-id="${options.data.Id}" data-tendangnhap="${options.data.TenDangNhap}" checked="checked">
                                    `;
                                }else{
                                    _html = `
                                    <input class="action_setting_isScan cursor_pointer" type="checkbox" value="${options.data.isScan}" data-id="${options.data.Id}" data-tendangnhap="${options.data.TenDangNhap}">
                                    `;
                                }
                                $(container).html(_html);
                            }
                        },
                        {
                            headerCellTemplate: function(container) {
                                container.text('STT').parent().css({fontWeight: 'bold', backgroundColor: '#c5d3dd'});
                            },
                            width: 50,
                            //dataField: "STT",
                            alignment: "center",
                            cellTemplate: function (container, options) {
                                let _stt = options.rowIndex + 1;
                                $(container).html(_stt);
                            }
                        },
                        {
                            headerCellTemplate: function(container) {
                                container.text('Tên đăng nhập').parent().css({fontWeight: 'bold', backgroundColor: '#c5d3dd'});
                            },
                            dataField: "TenDangNhap",
                            alignment: "center",
                            minWidth: 90,
                            cellTemplate: function (container, options) {
                                $(container).html(options.value);
                            },
                            caption : "Tên đăng nhập"
                        },
                        {
                            headerCellTemplate: function(container) {
                                container.text('Email').parent().css({fontWeight: 'bold', backgroundColor: '#c5d3dd'});
                            },
                            dataField: "Email",
                            cellTemplate: function (container, options) {
                                $(container).html(options.value);
                            }
                        },
                        //{
                        //    headerCellTemplate: function(container) {
                        //        container.text('Đơn vị').parent().css({fontWeight: 'bold', textAlign: 'center', backgroundColor: '#c5d3dd'});
                        //    },
                        //    dataField: "TenDonVi",
                        //    cellTemplate: function (container, options) {
                        //        $(container).html(options.value);
                        //    },
                        //    caption : "Đơn vị"
                        //},
                        //{
                        //    headerCellTemplate: function(container) {
                        //        container.text('Mã nhân viên').parent().css({fontWeight: 'bold', backgroundColor: '#c5d3dd'});
                        //    },
                        //    dataField: "MaNhanVien",
                        //    cellTemplate: function (container, options) {
                        //        $(container).html(options.value);
                        //    },
                        //    caption : "Mã nhân viên"
                        //},
                        {
                            headerCellTemplate: function(container) {
                                container.text('').parent().css({fontWeight: 'bold', textAlign: 'center', backgroundColor: '#c5d3dd'});
                            },
                            minWidth: 60,
                            dataField: "",
                            alignment: "center",
                            cellTemplate: function (container, options) {
                                //console.log(options);
                                let _html = `
                                    <input type="radio" name="showDonVi" class="action_load_danhsach_donvi cursor_pointer" data-id="${options.data.Id}"  data-tendangnhap="${options.data.TenDangNhap}" id="customRadio_${options.data.Id}">
                                    <label class="cursor_pointer fa fa-forward" for="customRadio_${options.data.Id}">
                                    </label>
                                    `;
                                $(container).html(_html);
                            }
                        }
                    ],
                summary: {
                    totalItems:
                        [
                            {
                                column: 'TenDangNhap',
                                summaryType: 'count',
                            }
                        ],
                }
            });
        })
        .fail(function(error) {
            console.log("error", error);
        });
    };
    load_danhsach_user();

    /* Setting isScan cho tài khoản */
    $("#gridContainer_User").on('click', '.action_setting_isScan', function(e) {
        let _id = $(e.target).attr('data-id');
        let _TenDangNhap = $(e.target).attr('data-tendangnhap');
        let _value = $(e.target).val();
        let _value_boolen = _value.toLowerCase() === 'true' || _value === '1' ? true : false;
        let dataPost = {
            Id: _id,
            isCheck: !_value_boolen,
            TenDangNhap: _TenDangNhap
        };
        console.log(dataPost);
        if(_id){
            $('#gridContainer_User').addClass('loading_content');
            $.ajax({
                url: '@Url.Action("SetIsScanTaiKhoan", "VanPhongSo")',
                type: 'POST',
                dataType: 'json',
                data: dataPost,
            })
            .done(function(response) {
                $(e.target).val(!_value_boolen);
                //$(e.target).prop('checked', !_value_boolen);
                doNotify("Phân quyền Scan thành công");
            })
            .fail(function() {
                doNotify("Đã xãy ra lỗi. hãy tải lại trang web(F5)","danger");
            })
            .always(function() {
                $('#gridContainer_User').removeClass('loading_content');
            });

        }
    });
    /* Setting isTruongPhong cho tài khoản */
    $("#gridContainer_User").on('click', '.action_setting_isTruongPhong', function(e) {
        let _id = $(e.target).attr('data-id');
        let _TenDangNhap = $(e.target).attr('data-tendangnhap');
        let _value = $(e.target).val();
        let _value_boolen = _value.toLowerCase() === 'true' || _value === '1' ? true : false;
        let dataPost = {
            Id: _id,
            isCheck: !_value_boolen,
            TenDangNhap: _TenDangNhap
        };
        console.log(dataPost);
        if(_id){
            $('#gridContainer_User').addClass('loading_content');
            $.ajax({
                url: '@Url.Action("SetIsTruongPhongTaiKhoan", "VanPhongSo")',
                type: 'POST',
                dataType: 'json',
                data: dataPost,
            })
            .done(function(response) {
                $(e.target).val(!_value_boolen);
                //$(e.target).prop('checked', !_value_boolen);
                doNotify("Phân quyền Trưởng phòng thành công");
            })
            .fail(function() {
                doNotify("Đã xãy ra lỗi. hãy tải lại trang web(F5)","danger");
            })
            .always(function() {
                $('#gridContainer_User').removeClass('loading_content');
            });

        }
    });
    
    /* Setting isVPS cho tài khoản */
    $("#gridContainer_User").on('click', '.action_setting_isVPS', function(e) {
        let _id = $(e.target).attr('data-id');
        let _TenDangNhap = $(e.target).attr('data-tendangnhap');
        let _value = $(e.target).val();
        let _value_boolen = _value.toLowerCase() === 'true' || _value === '1' ? true : false;
        let dataPost = {
            Id: _id,
            isCheck: !_value_boolen,
            TenDangNhap: _TenDangNhap
        };
        console.log(dataPost);
        if(_id){
            $('#gridContainer_User').addClass('loading_content');
            $.ajax({
                url: '@Url.Action("SetIsVPSTaiKhoan", "VanPhongSo")',
                type: 'POST',
                dataType: 'json',
                data: dataPost,
            })
            .done(function(response) {
                $(e.target).val(!_value_boolen);
                //$(e.target).prop('checked', !_value_boolen);
                doNotify("Phân quyền vào VPS thành công");
            })
            .fail(function() {
                doNotify("Đã xãy ra lỗi. hãy tải lại trang web(F5)","danger");
            })
            .always(function() {
                $('#gridContainer_User').removeClass('loading_content');
            });

        }
    });

    /* Tải danh sách Đơn Vị theo User */
    $("#gridContainer_User").on('click', '.action_load_danhsach_donvi', function(e) {
        let _id = $(e.target).attr('data-id');
        let _TenDangNhap = $(e.target).attr('data-tendangnhap');
        let data = {
            Id: _id,
            TenDangNhap: _TenDangNhap
        };
        //console.log(data);
        if(_id){
            $("#selected_taikhoan").html(`cho tài khoản <span class="text-danger">${_TenDangNhap} (id: ${_id})</span>`);
            $('#gridContainer_User').addClass('loading_content');
            $('#gridContainer_DonVi').addClass('loading_content');
            load_danhsach_donvi(data.TenDangNhap);
        }
    });
</script>

<!-- Đơn vị List -->
<script type="text/javascript">
    function load_danhsach_donvi(_tenDangNhap=""){
        if(_tenDangNhap){
            $.ajax({
                url: '@Url.Action("GetDanhSachDonVi", "VanPhongSo")',
                type: 'GET',
                dataType: 'json',
                data: { TenDangNhap: _tenDangNhap }
            })
            .done(function(response) {
                
                $('#gridContainer_DonVi').dxDataGrid({
                    dataSource: response,
                    keyExpr: 'Id',
                    showBorders: true,
                    showRowLines: true,
                    paging: {
                        enabled: false
                    },
                    columnAutoWidth: true,
                    columnFixing: {
                        enabled: true
                    },
                    filterRow: {
                        visible: true,
                        applyFilter: 'auto',
                    },
                    // filterPanel: { visible: true },
                    headerFilter: { visible: true },
                    columns:
                        [

                            {
                                headerCellTemplate: function(container) {
                                    container.text('').parent().css({fontWeight: 'bold', textAlign: 'center', backgroundColor: '#c5d3dd'});
                                },
                                width: 90,
                                fixed: true,
                                dataField: "",
                                alignment: "center",
                                cellTemplate: function (container, options) {
                                    //console.log(options);
                                    let html = '';
                                    if(options.data.isCheck){
                                        html = `
                                        <input class="action_setting_isCheck_DonVi cursor_pointer" type="checkbox" value="${options.data.isCheck}" data-user="${_tenDangNhap}" data-id="${options.data.Id}" data-tendonvi="${options.data.TenDonVi}" checked="checked">
                                        `;
                                    }else{
                                        html = `
                                         <input class="action_setting_isCheck_DonVi cursor_pointer" type="checkbox" value="${options.data.isCheck}" data-user="${_tenDangNhap}" data-id="${options.data.Id}" data-tendonvi="${options.data.TenDonVi}">
                                        `;
                                    }
                                    $(container).html("<h5>"+html+"</h5>");
                                }
                            },
                            {
                                headerCellTemplate: function(container) {
                                    container.text('STT').parent().css({fontWeight: 'bold', backgroundColor: '#c5d3dd'});
                                },
                                width: 50,
                                //dataField: "STT",
                                alignment: "center",
                                cellTemplate: function (container, options) {
                                    let _stt = options.rowIndex + 1;
                                    $(container).html(_stt);
                                }
                            },
                            {
                                headerCellTemplate: function(container) {
                                    container.text('Đơn vị').parent().css({fontWeight: 'bold', textAlign: 'center', backgroundColor: '#c5d3dd'});
                                },
                                dataField: "TenDonVi",
                                cellTemplate: function (container, options) {
                                    $(container).html(options.value);
                                }
                            }
                        ],
                    summary: {
                        totalItems:
                            [
                                {
                                    column: 'TenDonVi',
                                    summaryType: 'count',
                                }
                            ],
                    },
                    onContentReady: function(e) {
                        $('#gridContainer_User').removeClass('loading_content');
                        $('#gridContainer_DonVi').removeClass('loading_content');
                    }
                });
            })
            .fail(function(error) {
                console.log("error", error);
            });
        }else{
            console.log('load_danhsach_donvi: không lấy được _idUser');
        }
    };


    /* Setting isCheck cho Đơn Vị */
    $("#gridContainer_DonVi").on('click', '.action_setting_isCheck_DonVi', function(e) {
        let _id = $(e.target).attr('data-id');
        let _tenDangNhap = $(e.target).attr('data-user');
        let _TenDonVi = $(e.target).attr('data-tendonvi');
        let _value = $(e.target).val();
        let _value_boolen = _value.toLowerCase() === 'true' || _value === '1' ? true : false;
        let _idUser = Number( $('#gridContainer_User input[name=showDonVi]:checked').attr('data-id') );
        console.log(_idUser);
        let dataPost = {
            Id: _id,
            isCheck: !_value_boolen,
            TenDonVi: _TenDonVi,
            TenDangNhap : _tenDangNhap
        };
        //console.log(dataPost);
        if(_idUser && Number.isInteger(_idUser) && _id){
            $('#gridContainer_DonVi').addClass('loading_content');
            $.ajax({
                url: '@Url.Action("SetPhanQuyenDonViTaiKhoan", "VanPhongSo")',
                type: 'POST',
                dataType: 'json',
                data: dataPost,
            })
            .done(function(response) {
                $(e.target).val(!_value_boolen);
                doNotify("Phân quyền Đơn vị thành công");
            })
            .fail(function() {
                doNotify("Đã xãy ra lỗi. hãy tải lại trang web(F5)","danger");
            })
            .always(function() {
                $('#gridContainer_DonVi').removeClass('loading_content');
            });

        }else{
            doNotify(`Lỗi lấy thông tin <br>IdUser:${_idUser}<br>IdDonVi:${_id}`,"danger");
        }
        // alert(message?: DOMString);
        /* Act on the event */
    });
</script>
